windowFunctions['Select Users for Group'] = function (evt) {
    var win = createWindow();
    var offset = addBackButton(win);

    var checked = {};

    var table = Ti.UI.createTableView({
        backgroundColor: '#fff',
        top: offset + u, bottom: 0,
        data: [
            { title: 'Loading, please wait...' }
        ]
    });
    table.addEventListener('click', function (evt) {
        if (evt.row.id) {
            evt.row.hasCheck = !evt.row.hasCheck;
            checked[evt.row.id] = evt.row.hasCheck;
            if (!evt.row.hasCheck) {
                delete checked[evt.row.id];
            }
        }
        else {
            var ids = [];
            for (var id in checked) {
                if (!checked.hasOwnProperty(id)) {
                    continue;
                }
                ids.push(id);
            }
            if (ids.length) {
                handleOpenWindow({ target: 'Show Chat Group', ids: ids });
            } else {
                alert('Please check at least one user!');
            }
        }
    });
    win.add(table);

    win.addEventListener('open', function () {
        Cloud.Users.query(function (e) {
            if (e.success) {
                if (e.users.length == 0) {
                    table.setData([
                        { title: 'No Other Users! Cannot chat!' }
                    ]);
                }
                else {
                    var data = [];
                    data.push({ title: 'Start Chatting!' });
                    for (var i = 0, l = e.users.length; i < l; i++) {
                        data.push(Ti.UI.createTableViewRow({
                            title: e.users[i].first_name + ' ' + e.users[i].last_name,
                            id: e.users[i].id
                        }));
                    }
                    table.setData(data);
                }
            }
            else {
                table.setData([
                    { title: (e.error && e.message) || e }
                ]);
                error(e);
            }
        });
    });
    win.open();
};