Ti.include(
    'notify.js',
    'subscribe.js',
    'unsubscribe.js'
);

var pushDeviceToken;
if (Ti.Network && Ti.Network.registerForPushNotifications) {
    Ti.Network.registerForPushNotifications({
        types: [
            Ti.Network.NOTIFICATION_TYPE_BADGE,
            Ti.Network.NOTIFICATION_TYPE_ALERT,
            Ti.Network.NOTIFICATION_TYPE_SOUND
        ],
        success: function (e) {
            pushDeviceToken = e.deviceToken;
        },
        error: function (e) {
            Ti.API.error('Failed to register for push! ' + e.error);
        },
        callback: function (e) {
            alert('Received push: ' + JSON.stringify(e));
        }
    });
}
else {
    // TODO: Android support for push notifications is coming soon!
}

windowFunctions['Push Notifications'] = function () {
    var win = createWindow();
    var offset = addBackButton(win);

    var rows = [ 'Notify' ];
    if (pushDeviceToken) {
        rows.push('Subscribe');
        rows.push('Unsubscribe');
    }
    else {
        Ti.API.error('NOTE: This device does not support push notifications!');
    }

    var table = Ti.UI.createTableView({
        backgroundColor: '#fff',
        top: offset + u,
        data: createRows(rows)
    });
    table.addEventListener('click', handleOpenWindow);
    win.add(table);
    win.open();
};